| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | |
| 3 | ## |
| tierno | 9202102 | 2018-09-12 16:29:23 +0200 | [diff] [blame] | 4 | # Copyright 2015 Telefonica Investigacion y Desarrollo, S.A.U. |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 5 | # This file is part of openmano |
| 6 | # All Rights Reserved. |
| 7 | # |
| 8 | # Licensed under the Apache License, Version 2.0 (the "License"); you may |
| 9 | # not use this file except in compliance with the License. You may obtain |
| 10 | # a copy of the License at |
| 11 | # |
| 12 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 13 | # |
| 14 | # Unless required by applicable law or agreed to in writing, software |
| 15 | # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT |
| 16 | # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the |
| 17 | # License for the specific language governing permissions and limitations |
| 18 | # under the License. |
| 19 | # |
| 20 | # For those usages not covered by the Apache License, Version 2.0 please |
| 21 | # contact with: nfvlabs@tid.es |
| 22 | ## |
| 23 | |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 24 | #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 25 | #Get needed packages, source code and configure to run openmano |
| 26 | #Ask for database user and password if not provided |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 27 | |
| 28 | function usage(){ |
| Igor D.C | bf669b9 | 2017-10-23 13:36:03 +0000 | [diff] [blame] | 29 | echo -e "usage: sudo -E $0 [OPTIONS]" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 30 | echo -e "Install last stable source code in ./openmano and the needed packages" |
| 31 | echo -e "On a Ubuntu 16.04 it configures openmano as a service" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 32 | echo -e " OPTIONS" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 33 | echo -e " -u USER: database admin user. 'root' by default. Prompts if needed" |
| 34 | echo -e " -p PASS: database admin password to be used or installed. Prompts if needed" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 35 | echo -e " -q --quiet: install in unattended mode" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 36 | echo -e " -h --help: show this help" |
| tierno | edaf0c3 | 2017-11-02 11:41:19 +0100 | [diff] [blame] | 37 | echo -e " -b REFSPEC: install from source code using a specific branch (master, v2.0, ...) or tag" |
| 38 | echo -e " -b master (main RO branch)" |
| 39 | echo -e " -b v2.0 (v2.0 branch)" |
| 40 | echo -e " -b tags/v1.1.0 (a specific tag)" |
| 41 | echo -e " ..." |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 42 | echo -e " --develop: install last version for developers, and do not configure as a service" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 43 | echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 44 | echo -e " --updatedb: do not reinstall mano_db DB if it exists, just update database" |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 45 | echo -e " --force: makes idenpotent, delete previous installations folders if needed. It assumes --updatedb if --forcedb option is not provided" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 46 | echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo" |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 47 | echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation" |
| garciadeblas | 5b1a664 | 2017-04-18 10:10:31 +0200 | [diff] [blame] | 48 | echo -e " --no-db: do not install mysql server" |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 49 | } |
| 50 | |
| 51 | function install_packages(){ |
| 52 | [ -x /usr/bin/apt-get ] && apt-get install -y $* |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 53 | [ -x /usr/bin/yum ] && yum install -y $* |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 54 | |
| 55 | #check properly installed |
| 56 | for PACKAGE in $* |
| 57 | do |
| 58 | PACKAGE_INSTALLED="no" |
| 59 | [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes" |
| 60 | [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes" |
| 61 | if [ "$PACKAGE_INSTALLED" = "no" ] |
| 62 | then |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 63 | echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2 |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 64 | exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 65 | fi |
| 66 | done |
| 67 | } |
| 68 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 69 | function ask_user(){ |
| 70 | # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive |
| 71 | # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed |
| 72 | # Return: true(0) if user type 'yes'; false (1) if user type 'no' |
| 73 | read -e -p "$1" USER_CONFIRMATION |
| 74 | while true ; do |
| 75 | [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0 |
| 76 | [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1 |
| 77 | [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0 |
| 78 | [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1 |
| 79 | read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION |
| 80 | done |
| 81 | } |
| 82 | |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 83 | GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git |
| tierno | a7f744d | 2018-09-10 11:04:31 +0200 | [diff] [blame] | 84 | export GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git |
| 85 | export GIT_OSMIM_URL=https://osm.etsi.org/gerrit/osm/IM.git |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 86 | DBUSER="root" |
| 87 | DBPASSWD="" |
| 88 | DBPASSWD_PARAM="" |
| 89 | QUIET_MODE="" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 90 | DEVELOP="" |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 91 | DB_FORCE_UPDATE="" |
| 92 | UPDATEDB="" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 93 | FORCE="" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 94 | NOCLONE="" |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 95 | NO_PACKAGES="" |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 96 | NO_DB="" |
| tierno | edaf0c3 | 2017-11-02 11:41:19 +0100 | [diff] [blame] | 97 | COMMIT_ID="" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 98 | |
| tierno | edaf0c3 | 2017-11-02 11:41:19 +0100 | [diff] [blame] | 99 | while getopts ":u:p:b:hiq-:" o; do |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 100 | case "${o}" in |
| 101 | u) |
| 102 | export DBUSER="$OPTARG" |
| 103 | ;; |
| 104 | p) |
| 105 | export DBPASSWD="$OPTARG" |
| 106 | export DBPASSWD_PARAM="-p$OPTARG" |
| 107 | ;; |
| tierno | edaf0c3 | 2017-11-02 11:41:19 +0100 | [diff] [blame] | 108 | b) |
| 109 | export COMMIT_ID=${OPTARG} |
| 110 | ;; |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 111 | q) |
| 112 | export QUIET_MODE=yes |
| 113 | export DEBIAN_FRONTEND=noninteractive |
| 114 | ;; |
| 115 | h) |
| 116 | usage && exit 0 |
| 117 | ;; |
| 118 | -) |
| 119 | [ "${OPTARG}" == "help" ] && usage && exit 0 |
| tierno | a7f744d | 2018-09-10 11:04:31 +0200 | [diff] [blame] | 120 | [ "${OPTARG}" == "develop" ] && export DEVELOP="y" && continue |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 121 | [ "${OPTARG}" == "forcedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--forcedb" && continue |
| 122 | [ "${OPTARG}" == "updatedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--updatedb" && continue |
| 123 | [ "${OPTARG}" == "force" ] && FORCE="y" && continue |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 124 | [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 125 | [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 126 | [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 127 | [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 128 | echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 129 | exit 1 |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 130 | ;; |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 131 | \?) |
| 132 | echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2 |
| 133 | exit 1 |
| 134 | ;; |
| 135 | :) |
| 136 | echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2 |
| 137 | exit 1 |
| 138 | ;; |
| 139 | *) |
| 140 | usage >&2 |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 141 | exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 142 | ;; |
| 143 | esac |
| 144 | done |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 145 | |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 146 | if [ "$DB_FORCE_UPDATE" == "--forcedb--updatedb" ] || [ "$DB_FORCE_UPDATE" == "--updatedb--forcedb" ] ; then |
| 147 | echo "Error: options --forcedb and --updatedb are mutually exclusive" >&2 |
| 148 | exit 1 |
| 149 | elif [ -n "$FORCE" ] && [ -z "$DB_FORCE_UPDATE" ] ; then |
| 150 | DB_FORCE_UPDATE="--updatedb" |
| 151 | fi |
| 152 | |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 153 | #check root privileges and non a root user behind |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 154 | [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 155 | if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]] |
| 156 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 157 | [[ -z $QUIET_MODE ]] && ! ask_user "Install in the root user (y/N)? " n && echo "Cancelled" && exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 158 | export SUDO_USER=root |
| 159 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 160 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 161 | # Discover Linux distribution |
| 162 | # try redhat type |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 163 | [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1) |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 164 | # if not assuming ubuntu type |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 165 | [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null) |
| 166 | if [ "$_DISTRO" == "Ubuntu" ] |
| 167 | then |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 168 | _RELEASE=$(lsb_release -rs) |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 169 | if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]] |
| 170 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 171 | [[ -z $QUIET_MODE ]] && |
| 172 | ! ask_user "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)' (y/N)? " n && |
| 173 | echo "Cancelled" && exit 1 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 174 | _RELEASE = 14 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 175 | fi |
| 176 | elif [ "$_DISTRO" == "CentOS" ] |
| 177 | then |
| 178 | _RELEASE="7" |
| 179 | if ! cat /etc/redhat-release | grep -q "7." |
| 180 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 181 | [[ -z $QUIET_MODE ]] && |
| 182 | ! ask_user "WARNING! Not tested CentOS version. Continue assuming a '$_RELEASE' type (y/N)? " n && |
| 183 | echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 184 | fi |
| 185 | elif [ "$_DISTRO" == "Red" ] |
| 186 | then |
| 187 | _RELEASE="7" |
| 188 | if ! cat /etc/redhat-release | grep -q "7." |
| 189 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 190 | [[ -z $QUIET_MODE ]] && |
| 191 | ! ask_user "WARNING! Not tested Red Hat OS version. Continue assuming a '$_RELEASE' type (y/N)? " n && |
| 192 | echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 193 | fi |
| 194 | else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ] |
| 195 | _DISTRO_DISCOVER=$_DISTRO |
| 196 | [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14" |
| 197 | [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 198 | [[ -z $QUIET_MODE ]] && |
| 199 | ! ask_user "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type (y/N)? " n && |
| 200 | echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 201 | fi |
| 202 | |
| tierno | a7f744d | 2018-09-10 11:04:31 +0200 | [diff] [blame] | 203 | export _DISTRO="$_DISTRO" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 204 | #check if installed as a service |
| 205 | INSTALL_AS_A_SERVICE="" |
| 206 | [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 207 | |
| 208 | # Next operations require knowing BASEFOLDER |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 209 | if [[ -z "$NOCLONE" ]]; then |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 210 | if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then |
| tierno | a7f744d | 2018-09-10 11:04:31 +0200 | [diff] [blame] | 211 | export BASEFOLDER=__openmano__${RANDOM} |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 212 | else |
| tierno | a7f744d | 2018-09-10 11:04:31 +0200 | [diff] [blame] | 213 | export BASEFOLDER="${PWD}/openmano" |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 214 | fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 215 | [[ -n "$FORCE" ]] && rm -rf $BASEFOLDER #make idempotent |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 216 | else |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 217 | HERE=$(dirname $(readlink -f ${BASH_SOURCE[0]})) |
| tierno | a7f744d | 2018-09-10 11:04:31 +0200 | [diff] [blame] | 218 | export BASEFOLDER=$(dirname $HERE) |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 219 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 220 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 221 | if [[ -z "$NO_PACKAGES" ]] |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 222 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 223 | echo -e "\n"\ |
| 224 | "#################################################################\n"\ |
| 225 | "##### UPDATE REPOSITORIES #####\n"\ |
| 226 | "#################################################################" |
| tierno | 751a4ef | 2018-02-22 12:24:16 +0100 | [diff] [blame] | 227 | [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y && |
| Eduardo Sousa | e3c0dbc | 2018-09-03 11:56:07 +0100 | [diff] [blame] | 228 | add-apt-repository -y cloud-archive:queens && apt-get update -y |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 229 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 230 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y |
| Igor D.C | bf669b9 | 2017-10-23 13:36:03 +0000 | [diff] [blame] | 231 | [ "$_DISTRO" == "CentOS" ] && yum install -y epel-release |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 232 | [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \ |
| Igor D.C | bf669b9 | 2017-10-23 13:36:03 +0000 | [diff] [blame] | 233 | && rpm -ivh epel-release-7-5.noarch.rpm && yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm |
| 234 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum repolist |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 235 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 236 | echo -e "\n"\ |
| 237 | "#################################################################\n"\ |
| 238 | "##### INSTALL REQUIRED PACKAGES #####\n"\ |
| 239 | "#################################################################" |
| 240 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client" |
| 241 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client" |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 242 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 243 | echo -e "\n"\ |
| 244 | "#################################################################\n"\ |
| 245 | "##### INSTALL PYTHON PACKAGES #####\n"\ |
| 246 | "#################################################################" |
| tierno | 751a4ef | 2018-02-22 12:24:16 +0100 | [diff] [blame] | 247 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema "\ |
| 248 | "python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev "\ |
| Anderson Bravalheri | 0446cd5 | 2018-08-17 15:26:19 +0100 | [diff] [blame] | 249 | "python-pip python-crypto python-networkx" |
| tierno | 751a4ef | 2018-02-22 12:24:16 +0100 | [diff] [blame] | 250 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema "\ |
| 251 | "python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel "\ |
| Anderson Bravalheri | 0446cd5 | 2018-08-17 15:26:19 +0100 | [diff] [blame] | 252 | "python-pip python-crypto python-networkx" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 253 | # The only way to install python-bottle on Centos7 is with easy_install or pip |
| 254 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 255 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 256 | # required for vmware connector TODO move that to separete opt in install script |
| tierno | 6082b7d | 2018-08-31 11:24:08 +0000 | [diff] [blame] | 257 | pip2 install pip==9.0.3 || exit 1 # --upgrade pip install pip 10 that does not work |
| 258 | pip2 install pyvcloud==19.1.1 || exit 1 |
| 259 | pip2 install progressbar || exit 1 |
| 260 | pip2 install prettytable || exit 1 |
| 261 | pip2 install pyvmomi || exit 1 |
| bayramov | fe3f3c9 | 2016-10-04 07:53:41 +0400 | [diff] [blame] | 262 | |
| jomacarpe | ea2a73e | 2018-02-27 13:48:22 +0100 | [diff] [blame] | 263 | # required for OpenNebula connector |
| tierno | 6082b7d | 2018-08-31 11:24:08 +0000 | [diff] [blame] | 264 | pip2 install untangle || exit 1 |
| 265 | pip2 install -e git+https://github.com/python-oca/python-oca#egg=oca || exit 1 |
| jomacarpe | ea2a73e | 2018-02-27 13:48:22 +0100 | [diff] [blame] | 266 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 267 | # required for AWS connector |
| 268 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto" |
| 269 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exists with this name, or PIP should be used |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 270 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 271 | # install openstack client needed for using openstack as a VIM |
| tierno | b4c2239 | 2017-06-14 12:55:38 +0200 | [diff] [blame] | 272 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient "\ |
| 273 | "python-neutronclient python-cinderclient python-openstackclient" |
| 274 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install \ |
| 275 | python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient \ |
| 276 | python-openstackclient #TODO revise if gcc python-pip is needed |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 277 | fi # [[ -z "$NO_PACKAGES" ]] |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 278 | |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 279 | if [[ -z $NOCLONE ]]; then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 280 | echo -e "\n"\ |
| 281 | "#################################################################\n"\ |
| 282 | "##### DOWNLOAD SOURCE #####\n"\ |
| 283 | "#################################################################" |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 284 | if [[ -d "${BASEFOLDER}" ]] ; then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 285 | if [[ -n "$FORCE" ]] ; then |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 286 | echo "deleting '${BASEFOLDER}' folder" |
| 287 | rm -rf "$BASEFOLDER" #make idempotent |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 288 | elif [[ -z "$QUIET_MODE" ]] ; then |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 289 | ! ask_user "folder '${BASEFOLDER}' exists, overwrite (y/N)? " n && echo "Cancelled!" && exit 1 |
| 290 | rm -rf "$BASEFOLDER" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 291 | else |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 292 | echo "'${BASEFOLDER}' folder exists. Use "--force" to overwrite" >&2 && exit 1 |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 293 | fi |
| 294 | fi |
| tierno | edaf0c3 | 2017-11-02 11:41:19 +0100 | [diff] [blame] | 295 | su $SUDO_USER -c "git clone ${GIT_URL} ${BASEFOLDER}" || ! echo "Error cannot clone from '$GIT_URL'" >&2 || exit 1 |
| 296 | if [[ -n $COMMIT_ID ]] ; then |
| 297 | echo -e "Installing osm-RO from refspec: $COMMIT_ID" |
| 298 | su $SUDO_USER -c "git -C ${BASEFOLDER} checkout $COMMIT_ID" || |
| 299 | ! echo "Error cannot checkout '$COMMIT_ID' from '$GIT_URL'" >&2 || exit 1 |
| 300 | elif [[ -z $DEVELOP ]]; then |
| 301 | LATEST_STABLE_TAG=`git -C "${BASEFOLDER}" tag -l "v[0-9]*" | sort -V | tail -n1` |
| 302 | echo -e "Installing osm-RO from refspec: tags/${LATEST_STABLE_TAG}" |
| 303 | su $SUDO_USER -c "git -C ${BASEFOLDER} checkout tags/${LATEST_STABLE_TAG}" || |
| 304 | ! echo "Error cannot checkout 'tags/${LATEST_STABLE_TAG}' from '$GIT_URL'" >&2 || exit 1 |
| 305 | else |
| 306 | echo -e "Installing osm-RO from refspec: master" |
| 307 | fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 308 | su $SUDO_USER -c "cp ${BASEFOLDER}/.gitignore-common ${BASEFOLDER}/.gitignore" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 309 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 310 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 311 | echo -e "\n"\ |
| 312 | "#################################################################\n"\ |
| tierno | 4da1c24 | 2017-09-28 12:17:05 +0200 | [diff] [blame] | 313 | "##### INSTALLING OSM-IM LIBRARY #####\n"\ |
| 314 | "#################################################################" |
| tierno | a7f744d | 2018-09-10 11:04:31 +0200 | [diff] [blame] | 315 | ${BASEFOLDER}/scripts/install-osm-im.sh |
| 316 | OSM_IM_PATH=`python -c 'import osm_im; print osm_im.__path__[0]'` || |
| 317 | ! echo "ERROR installing python-osm-im library!!!" >&2 || exit 1 |
| tierno | 4da1c24 | 2017-09-28 12:17:05 +0200 | [diff] [blame] | 318 | |
| 319 | echo -e "\n"\ |
| 320 | "#################################################################\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 321 | "##### INSTALLING OVIM LIBRARY #####\n"\ |
| 322 | "#################################################################" |
| tierno | a7f744d | 2018-09-10 11:04:31 +0200 | [diff] [blame] | 323 | ${BASEFOLDER}/scripts/install-lib-osm-openvim.sh |
| 324 | OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'` || |
| 325 | ! echo "ERROR installing python-lib-osm-openvim library!!!" >&2 || exit 1 |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 326 | |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 327 | if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] |
| 328 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 329 | echo -e "\n"\ |
| 330 | "#################################################################\n"\ |
| 331 | "##### CONFIGURE firewalld #####\n"\ |
| 332 | "#################################################################" |
| 333 | if [[ -z $QUIET_MODE ]] || ask_user "Configure firewalld for openmanod port 9090 (Y/n)? " y |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 334 | then |
| 335 | #Creates a service file for openmano |
| 336 | echo '<?xml version="1.0" encoding="utf-8"?> |
| 337 | <service> |
| 338 | <short>openmanod</short> |
| 339 | <description>openmanod service</description> |
| 340 | <port protocol="tcp" port="9090"/> |
| 341 | </service>' > /etc/firewalld/services/openmanod.xml |
| 342 | #put proper permissions |
| 343 | pushd /etc/firewalld/services > /dev/null |
| 344 | restorecon openmanod.xml |
| 345 | chmod 640 openmanod.xml |
| 346 | popd > /dev/null |
| 347 | #Add the openmanod service to the default zone permanently and reload the firewall configuration |
| 348 | firewall-cmd --permanent --add-service=openmanod > /dev/null |
| 349 | firewall-cmd --reload > /dev/null |
| 350 | echo "done." |
| 351 | else |
| 352 | echo "skipping." |
| 353 | fi |
| 354 | fi |
| 355 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 356 | echo -e "\n"\ |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 357 | "#################################################################\n"\ |
| 358 | "##### CONFIGURE OPENMANO CLIENT #####\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 359 | "#################################################################" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 360 | #creates a link at ~/bin if not configured as a service |
| 361 | if [[ -z "$INSTALL_AS_A_SERVICE" ]] |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 362 | then |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 363 | su $SUDO_USER -c 'mkdir -p ${HOME}/bin' |
| 364 | su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano' |
| 365 | su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report' |
| 366 | su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano' |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 367 | su $SUDO_USER -c "ln -s '${BASEFOLDER}/openmano' "'${HOME}/bin/openmano' |
| 368 | su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report' |
| 369 | su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/service-openmano' "'${HOME}/bin/service-openmano' |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 370 | |
| 371 | #insert /home/<user>/bin in the PATH |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 372 | #skiped because normally this is done authomatically when ~/bin exists |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 373 | #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin" |
| 374 | #then |
| 375 | # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc" |
| 376 | # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc' |
| 377 | #fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 378 | |
| 379 | if [[ $SUDO_USER == root ]] |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 380 | then |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 381 | if ! echo $PATH | grep -q "${HOME}/bin" |
| 382 | then |
| 383 | echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc |
| 384 | fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 385 | fi |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 386 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 387 | |
| 388 | #configure arg-autocomplete for this user |
| 389 | #in case of minimal instalation this package is not installed by default |
| 390 | [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion |
| 391 | #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d' |
| 392 | su $SUDO_USER -c 'activate-global-python-argcomplete --user' |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 393 | if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 394 | then |
| 395 | echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 396 | su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 397 | fi |
| 398 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 399 | if [ -z "$NO_DB" ]; then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 400 | echo -e "\n"\ |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 401 | "#################################################################\n"\ |
| 402 | "##### INSTALL DATABASE SERVER #####\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 403 | "#################################################################" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 404 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 405 | if [ -n "$QUIET_MODE" ]; then |
| 406 | DB_QUIET='-q' |
| 407 | fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 408 | ${BASEFOLDER}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} $DB_QUIET $DB_FORCE_UPDATE || exit 1 |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 409 | echo -e "\n"\ |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 410 | "#################################################################\n"\ |
| 411 | "##### CREATE AND INIT MANO_VIM DATABASE #####\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 412 | "#################################################################" |
| 413 | # Install mano_vim_db after setup |
| 414 | ${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db --no-install-packages $DB_QUIET $DB_FORCE_UPDATE || exit 1 |
| 415 | fi # [ -z "$NO_DB" ] |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 416 | |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 417 | if [[ -n "$INSTALL_AS_A_SERVICE" ]] |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 418 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 419 | echo -e "\n"\ |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 420 | "#################################################################\n"\ |
| 421 | "##### CONFIGURE OPENMANO SERVICE #####\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 422 | "#################################################################" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 423 | |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 424 | ${BASEFOLDER}/scripts/install-openmano-service.sh -f ${BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"` |
| 425 | # rm -rf ${BASEFOLDER} |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 426 | # alias service-openmano="service openmano" |
| 427 | # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 428 | echo |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 429 | echo "Done! installed at /opt/openmano" |
| Igor D.C | bf669b9 | 2017-10-23 13:36:03 +0000 | [diff] [blame] | 430 | echo " Manage server with 'sudo -E service osm-ro start|stop|status|...' " |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 431 | else |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 432 | echo |
| 433 | echo "Done! you may need to logout and login again for loading client configuration" |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 434 | echo " Run './${BASEFOLDER}/scripts/service-openmano start' for starting openmano in a screen" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 435 | fi |